// 16 bit CCITT CRC calculation, one byte at a time.
//
// Carl D. Walker
// 02-03-99
// Released under GPL
//

#include "crc16.h"

// Constructor
crc16::crc16( void ) {
  crc16::init_crc16();
}

// Destructor
crc16::~crc16( void ) {
  // Null
}

// Subs
void crc16::calc_crc16 ( unsigned char byte_in ) {
  int i;
  int temp_crc = 0;
  crc16::byte_count++; //bump the count of bytes that we have processed
                       // so far...
  temp_crc = byte_in * 256;
  crc16::crc_running = temp_crc ^ crc16::crc_running;
  for ( i = 0; i <= 7; i++ ) {
    if ( crc16::crc_running > 32767 ) {
      crc16::crc_running = crc16::crc_running * 2;
      crc16::crc_running = crc16::crc_running ^ POLY16;
    }
    else {
      crc16::crc_running = crc16::crc_running * 2;
    }
    crc16::crc_running &= 0xFFFF;
  }
}

void crc16::init_crc16( void ) {
  crc16::crc_running = 0;
  crc16::byte_count = 0;
}

int crc16::return_crc16( void ) {
  return crc16::crc_running;
}

int crc16::return_byte_count( void ) {
  return crc16::byte_count;
}
