#include "snap_base.h"

snap_base::snap_base() {
  crc_16     = new crc16();
  checksum_8 = new checksum8();
}

snap_base::~snap_base() {
  delete crc_16;
  delete checksum_8;
}

void snap_base::set_debug_level( int debug_level_in ) {
  debug_level = debug_level_in;
}

int snap_base::get_debug_level( void ) {
  return debug_level;
}

float snap_base::get_version( void ) {
  return version;
}

void snap_base::set_node_address( int address_in ) {
 my_node_address = address_in;
}

int snap_base::get_node_address( void ) {
  return my_node_address;
}

void snap_base::report_function_error( report_err error_type ) {
  // complain when we can't support the incoming packet for some
  // reason or other, and also set the err_state, as the packet must be
  // corrupt, since we don't support some required mode!
  switch ( error_type ) {
  case e_err_mode:
    cout << "snap_rx::report_error_function: We don't support Error_Mode "
	 << " required for the incoming packet. PACKET CORRUPT" << endl;
    break;
    
  case e_general:
    cout << "snap_rx::report_error_function: We don't support some "
	 << "mode required for the packet. PACKET CORRUPT" << endl;
    break;

  default:
    cout << "snap_rx::report_error_function:default We don't support some "
	 << "mode required for the incoming packet. PACKET CORRUPT" << endl;    
  }  
  err_state = 1;
}

