#ifndef __SNAP_DEFINES__
#include "snap_defines.h"
#endif

#define __SNAP_BASE__

#include "crc16.h"
#include "checksum8.h"

enum report_err {e_err_mode, e_general};

class snap_base {
 public:
  snap_base();
  ~snap_base();
  // set the debugging level
  void snap_base::set_debug_level( int debug_level_in );
  // report the debugging level
  int snap_base::get_debug_level( void );
  // Get the version number
  float snap_base::get_version( void );
  // set my (local) node address
  void snap_base::set_node_address( int );
  // query my (local) node address
  int snap_base::get_node_address( void );

 protected:
  int debug_level;
  int my_node_address;
  float version;
  
  void snap_base::report_function_error( report_err error_type );

  // Common packet fields
  int snap_base::pfb_data;
  int snap_base::sab_data;
  int snap_base::dab_data;
  int snap_base::err_mode;
  // Common packet field sizes
  int snap_base::dab_size;
  int snap_base::sab_size;
  int snap_base::pfb_size;
  //
  int snap_base::err_state;
  // Error class pointers
  crc16     *crc_16;
  checksum8 *checksum_8;
  //

 private:

};
