#ifndef __SNAP_DEFINES__
#define __SNAP_DEFINES__
#endif
//
#include <iomanip.h>

#ifndef _IOSTREAM_
#include <iostream.h>
#define _IOSTREAM_
#endif
//
#ifndef _STRING_
#include <string.h>
#define _STRING_
#endif
//

// General defines
#define ERROR_MASK          0x7
#define TWO_BIT_MASK        0x3
#define NIBBLE_MASK         0xF
#define THREE_BYTE_MASK     0xFFFFFF
#define TWO_BYTE_MASK       0xFFFF
#define ONE_BYTE_MASK       0xFF
#define SYNC                0x54
#define RX_BUFFER_SIZE      1024
#define TX_BUFFER_LEN       1024
#define NO_ACK_REQ          0
#define ACK_REQ             1
#define ACK_REPLY           2 
#define NACK_REPLY          3
#define BROADCAST           0

// Command  mode defines
#define CMD_SUP_QUERY       0
#define CMD_SUP_REPLY       128
#define PREF_PACK_QUERY     1
#define PREF_PACK_REPLY     129

// Error mode defines
#define NO_ERR_MODE         0
#define MULT_ERR_MODE       1
#define BYTE_CKSUM_ERR_MODE 2
#define BYTE_CRC_ERR_MODE   3
#define WORD_CRC_ERR_MODE   4
#define DWORD_CRC_ERR_MODE  5
#define FEC_ERR_MODE        6
#define UDEF_ERR_MODE       7

// Address length defines
#define ADDR_0_BIT          0
#define ADDR_8_BIT          1
#define ADDR_16_BIT         2
#define ADDR_24_BIT         3

// Packet Byte Length defines
#define BYTE_16_LEN         9
#define BYTE_32_LEN         0xa
#define BYTE_64_LEN         0xb
#define BYTE_128_LEN        0xc
#define BYTE_256_LEN        0xd
#define BYTE_512_LEN        0xe
#define UDEF_BYTE_LEN       0xf
