#ifndef __SNAP_DEFINES__
#include "snap_defines.h"
#endif

#ifndef __SNAP_BASE__
#include "snap_base.h"
#endif

class snap_tx: public snap_base {

 private:
  // Globals for the class:
  char tx_data_buffer[ TX_BUFFER_LEN ];
  char tx_packet_out[ TX_BUFFER_LEN ];
  char *tx_data_ptr;
  char *tx_packet_ptr;
  int tx_packet_buffer_busy;
  int remote_node_address;
  float version;
  int debug_level;
  int tx_edm_mode;
  int dest_addr;
  int tx_data_length;
  int tx_data_length_buffer;
  int cmd;
  int ack_type;
  //
  int tx_packet_len;
  int raw_tx_byte_count;

  // internal housekeeping pointers and such
  int tx_data_offset;
  int rx_data_offset;
  int tx_packet_out_offset;

  //private modifiers and other functions
  void snap_tx::set_data_len( int );
  void snap_tx::set_address_bytes( int source_byte_len, int dest_byte_len );
  void snap_tx::add_sync( void );
  void snap_tx::address_byte_out( int len, int addr );
  void snap_tx::write_packet_byte( unsigned char byte_to_write );
  void snap_tx::calc_error( unsigned char byte_in );  
  void snap_tx::write_packet_error_bytes( void );

 public:
  snap_tx( int local_node_address, int debug );
  ~snap_tx();
  void snap_tx::set_edm( int error_mode_in );
  int snap_tx::get_edm( void );
  int snap_tx::get_dab_data( void );
  void snap_tx::set_dab_data( int dest_addr_in );
  char * snap_tx::build_tx_packet( void );
  void snap_tx::tx_packet_done( void );
  void snap_tx::set_sab_len( int length_in );
  void snap_tx::set_dab_len( int length_in );
  void snap_tx::set_pfb_len( int );
  void snap_tx::set_pfb_data( int );
  void snap_tx::set_cmd_mode( int command_in );
  void snap_tx::set_ack_type( int ack_in );
  char * snap_tx::comp_packet( void );
  void snap_tx::generate_header( void );
  int snap_tx::get_packet_len( void );
  int snap_tx::tx_data( char * data_in_ptr, int len );
};
